=== debian/changelog ===
clazy (1.8-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_inefficient-qlist-Disable-flaky-test-on-arm-32bit.patch: drop,
      backported from upstream
    - upstream_updated-for-compatibility-with-LLVM-10.patch: drop, backported
      from upstream
    - upstream_deleted-redundant-qualifier.patch: drop, backported from
      upstream
    - upstream_updated-for-compatibility-with-LLVM-10-clazy-standal.patch:
      drop, backported from upstream
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Bump Standards-Version to 4.5.1, no changes required.
  * Update the build dependencies according to the upstream build system:
    - bump clang & LLVM to 7.0
  * Backport upstream commit 04d38721ba951a9cafd276d584880d3f72c7794a, and
    commit c1dc65494574227646e1dd36675a5bd906660647 to fix two test cases;
    patches upstream_qt6-deprecated-api-fixes-Remove-unrelated-warnings-f.patch
    and upstream_qt6-qlatin1stringchar-to-u-Only-run-tests-with-clang.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 23 Nov 2020 19:34:07 +0100

clazy (1.7-5) unstable; urgency=medium

  * Upload to unstable.
  * Backport upstream commits 30d6a2b64f5a05722fdc5d8e3754dbf13425cd62,
    86796d87c9118cec4795d77349e3e607df35c3b8, and
    25aa102cc49def9573ffbed88155589cd60a2e8f to fix compatibility with
    LLVM >= 10; patches upstream_updated-for-compatibility-with-LLVM-10.patch,
    upstream_deleted-redundant-qualifier.patch, and
    upstream_updated-for-compatibility-with-LLVM-10-clazy-standal.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 02 Nov 2020 10:51:51 +0100

clazy (1.7-4) experimental; urgency=medium

  * Add a new package clazy-tests, mostly for autopkgtest purposes:
    - use --destdir=debian/clazy to install everything directly in clazy
    - make clazy-tests depend on the exact clazy version
    - make clazy-tests depend on the package (clang-tools-N) that provides
      the default version of clang-apply-replacements
  * Ship a shell file /usr/share/clazy/debian-$(DPKG_ARCHITECTURE).sh in
    clazy-tests with the paths of clang and clang-apply-replacements.
  * Adapt the run-tests autopkgtest to clazy-tests: (Closes: #952464, #971589)
    - replace the clang, and clang-tools dependencies with clazy-tests
    - source the shell configuration file provided by clazy-tests
    - export the right environment variables for clang, and
      clang-apply-replacements, so the upstream test script can use them
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Minimize the upstream GPG signing key.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Update references to the upstream Git repository.

 -- Pino Toscano <pino@debian.org>  Sun, 01 Nov 2020 19:06:17 +0100

clazy (1.7-3) unstable; urgency=medium

  * Backport upstream commit dbde38f1a67c2968c951629a5f5629c9847078bd to skip
    the inefficient-qlist test on any 32bit architecture; patch
    upstream_inefficient-qlist-Disable-flaky-test-on-arm-32bit.patch
    (Closes: #964137)
    - stop manually excluding it in rules

 -- Pino Toscano <pino@debian.org>  Sat, 04 Jul 2020 11:41:50 +0200
