=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Clark <sgclark@kde.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang (>= 1:7.0~),
               clang-tools (>= 1:7.0~),
               cmake (>= 3.7~),
               debhelper-compat (= 13),
               libclang-dev (>= 1:7.0~),
               llvm-dev (>= 1:7.0~),
               python3:any <!nocheck>,
               qtbase5-dev <!nocheck>,
               qtdeclarative5-dev <!nocheck>,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

Package: clazy-tests
Architecture: any
Depends: ${misc:Depends}, clazy (= ${binary:Version}),
         ${clazy:clang-tools},
Description: test files for Clazy
 This package contains all the test files needed for running the autopkgtest
 of Clazy. This is hardly useful to install in any other context than this.
