=== debian/changelog ===
clazy (1.9-3) unstable; urgency=medium

  * Exclude the qt6-header-fixes check on armel & armhf also when running the
    run-tests autopkgtest.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Jan 2021 16:17:14 +0100

clazy (1.9-2) unstable; urgency=medium

  * Exclude the qt6-header-fixes check on armel & armhf, as on these
    architectures there are the OpenGL ES headers that interfere with the test.

 -- Pino Toscano <pino@debian.org>  Mon, 11 Jan 2021 09:32:30 +0100

clazy (1.9-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_qt6-deprecated-api-fixes-Remove-unrelated-warnings-f.patch:
      drop, backported from upstream
    - upstream_qt6-qlatin1stringchar-to-u-Only-run-tests-with-clang.patch:
      drop, backported from upstream

 -- Pino Toscano <pino@debian.org>  Mon, 11 Jan 2021 00:54:37 +0100

clazy (1.8-2) unstable; urgency=medium

  * Add the libclang-cpp-dev build dependency to link against the shared
    libclang-cpp; hopefully this avoids problems when the LLVM version changes
    (due to the static linking).

 -- Pino Toscano <pino@debian.org>  Mon, 21 Dec 2020 12:17:32 +0100
