=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                clang-tools (>= 1:7.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
+               libclang-cpp-dev (>= 1:7.0~),
                libclang-dev (>= 1:7.0~),
                llvm-dev (>= 1:7.0~),
                python3:any <!nocheck>,
