## clazy 1.10

=== debian/changelog ===
clazy (1.10-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump clang & LLVM to 8.0
  * Pass -DREADLINK_CMD:FILEPATH=/usr/bin/readlink to cmake to force the path
    of readlink(1), so it does not change depending on usrmerge.

 -- Pino Toscano <pino@debian.org>  Tue, 17 Aug 2021 06:02:34 +0200
