=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang (>= 1:7.0~),
-               clang-tools (>= 1:7.0~),
+               clang (>= 1:8.0~),
+               clang-tools (>= 1:8.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
-               libclang-cpp-dev (>= 1:7.0~),
-               libclang-dev (>= 1:7.0~),
-               llvm-dev (>= 1:7.0~),
+               libclang-cpp-dev (>= 1:8.0~),
+               libclang-dev (>= 1:8.0~),
+               llvm-dev (>= 1:8.0~),
                python3:any <!nocheck>,
                qtbase5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,
