=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)"
+	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/usr/bin/readlink
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/clazy
