## clazy 1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,14 +19,14 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "9")
+set(CLAZY_VERSION_MINOR "11")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 7.0 MODULE REQUIRED)
+  find_package(Clang 8.0 MODULE REQUIRED)
 
   if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
     set(default_use_clang_cpp ON)
@@ -47,6 +47,14 @@
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 option(CLAZY_MAN_PAGE "Builds the man page." ON)
+option(CLAZY_ENABLE_SANITIZERS "Builds clazy with ASAN/UBSAN. For clazy's own development only." OFF)
+
+if (CLAZY_ENABLE_SANITIZERS)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
+    if (NOT MSVC)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
+    endif()
+endif()
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -61,7 +69,7 @@
   # disable trigger-happy warnings from Clang/LLVM headers
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
 elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
 endif()
 
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
@@ -83,12 +91,14 @@
   include_directories(${Boost_INCLUDE_DIRS})
 endif()
 
+set(CMAKE_CXX_STANDARD 17)
+set(CXX_STANDARD_REQUIRED ON)
+
 # Compiler might support c++17 but not have std::filesystem in the standard library
 message("Looking for std::filesystem support...")
 try_run(FILESYSTEM_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
 
 if (FILESYSTEM_RUN_RESULT EQUAL 0 AND COMPILE_RESULT)
-    set(CMAKE_CXX_STANDARD 17)
     add_definitions(-DHAS_STD_FILESYSTEM)
 endif()
 
@@ -313,9 +323,3 @@
         set(str ${input_string})
         set(chunk_size 1000)
         set(result "\n")
-        string(LENGTH ${str} str_size)
-        while (${str_size} GREATER ${chunk_size})
-            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
-            string(SUBSTRING ${str} ${chunk_size} -1 str)
-            set(chunk "R\"meta(${chunk})meta\"\n")
-            string(APPEND result ${chunk})
