=== debian/changelog ===
clazy (1.11-4ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:40:01 +1100

clazy (1.11-4ubuntu1) noble; urgency=medium

  * Explicitly build with LLVM 15, as done before.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 21:59:53 +0100

clazy (1.11-4build1) noble; urgency=medium

  * No-change rebuild against libllvm.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 20:23:57 +0100

clazy (1.11-4) unstable; urgency=medium

  * Team upload.
  * Remove the second reserve-candidates test.

 -- Simon Quigley <tsimonq2@debian.org>  Wed, 18 Jan 2023 14:40:12 -0600

clazy (1.11-3) unstable; urgency=medium

  * Export $DEB_HOST_ARCH in the 'run-tests' autopkgtest: this way, the local
    changes to run_tests.py can enable the linking to atomic on armel, where
    it is needed; this fixed the autopkgtest on that architecture.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Nov 2022 12:19:43 +0100

clazy (1.11-2) unstable; urgency=medium

  * Backport upstream commit f5c95d3cb453ca16980db268556f23ca3cd38122 to fix
    the detection of the clang version when running the tests; patch
    upstream_tests-fix-clang-version-regexp.patch.
  * Update standards version to 4.6.1, no changes needed.
  * Limit the parallel jobs for the tests ran during the build using
    $DEB_BUILD_OPTIONS:
    - backport upstream commit ab8993c9e10e09cb24210f76bb5e67f01bb37a9e to add
      -j/--jobs to the run_tests.py script; patch
      upstream_tests-add-j-jobs-option-for-run_tests.py.patch
    - pass --jobs to run_tests.py with the number of parallel jobs specified
      in $DEB_BUILD_OPTIONS, defaulting to 1
  * Set the number of parallel jobs in the 'run-tests' autopkgtest to 1 for
    now.
  * Remove inactive Uploaders.
  * Backport upstream commit 20fca52da739ebefa47e35f6b338bb99a0da3cfe to support
    LLVM/Clang 15.0.0; patch upstream_Build-fixes-for-LLVM-Clang-15.0.0.patch.

 -- Pino Toscano <pino@debian.org>  Thu, 17 Nov 2022 20:21:31 +0100

clazy (1.11-1) unstable; urgency=medium

  * New upstream release.
  * Drop -std=gnu++14 from the CXXFLAGS, as it should build fine now.
  * Update the patches:
    - select-clangpp.diff: refresh

 -- Pino Toscano <pino@debian.org>  Sat, 22 Jan 2022 11:11:20 +0100

clazy (1.10-2) unstable; urgency=medium

  * Fix -DREADLINK_CMD:FILEPATH to be /bin/readlink, like the actual file path
    provided by coreutils.
  * Bump Standards-Version to 4.6.0, no changes required.
  * Add -std=gnu++14 to the CXXFLAGS to build with C++14, as it seems it fails
    to build with C++17 (default of GCC 11).

 -- Pino Toscano <pino@debian.org>  Mon, 22 Nov 2021 22:38:47 +0100
