=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Scarlett Clark <sgclark@kde.org>,
- Pino Toscano <pino@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang (>= 1:8.0~),
-               clang-tools (>= 1:8.0~),
+               clang-15 (>= 1:8.0~),
+               clang-tools-15 (>= 1:8.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
-               libclang-cpp-dev (>= 1:8.0~),
-               libclang-dev (>= 1:8.0~),
-               llvm-dev (>= 1:8.0~),
+               libclang-cpp15-dev (>= 1:8.0~),
+               libclang-15-dev (>= 1:8.0~),
+               llvm-15-dev (>= 1:8.0~),
                python3:any <!nocheck>,
                qtbase5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
