=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildopts.mk
+
+export PATH := /usr/lib/llvm-15/bin:$(PATH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -27,7 +30,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/usr/bin/readlink
+	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/bin/readlink
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/clazy
@@ -46,7 +49,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
-	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose $(RUN_TESTS_ARGS)
+	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose --jobs $(or $(DEB_BUILD_OPTION_PARALLEL),$(DEB_BUILD_OPTION_PARALLEL),1) $(RUN_TESTS_ARGS)
 endif
 
 override_dh_compress:
