=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://download.kde.org/stable/@PACKAGE@/([\d\.]*)/src/@PACKAGE@-([^-]*).tar.xz
