## clazy 1.12

=== debian/changelog ===
clazy (1.12-1) unstable; urgency=medium

  * New upstream release:
    - supports up to LLVM 18 (Closes: #1051858)
  * Update standards version to 4.7.0, no changes needed.
  * Clean the generated files of the test suite run. (Closes: #1044015)
  * Update the patches:
    - upstream_tests-fix-clang-version-regexp.patch: drop, backported from
      upstream
    - upstream_tests-add-j-jobs-option-for-run_tests.py.patch: drop, backported
      from upstream
    - upstream_Build-fixes-for-LLVM-Clang-15.0.0.patch: drop, backported from
      upstream
    - debian-tests-link-atomic.diff: refresh/update
    - select-clangpp.diff: refresh
    - disable-reserve-candidates-flaky.patch: drop, no more needed
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.8
    - bump clang & LLVM to 11.0
  * Add more dependencies as test build dependency, and for the 'run-tests'
    autopkgtest, needed by the new upstream release:
    - libqt5networkauth5-dev, libqt5svg5-dev, qtmultimedia5-dev
    - qt6-base-dev, qt6-declarative-dev, qt6-multimedia-dev,
      qt6-networkauth-dev, qt6-scxml-dev, qt6-svg-dev
  * Update the license file to drop from the installed documentation.
  * The rebuild will make it usable with GCC 13. (Closes: #1043011)

 -- Pino Toscano <pino@debian.org>  Thu, 04 Jul 2024 20:06:47 +0200
