=== debian/control ===
--- 
+++ 
@@ -1,21 +1,29 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-15 (>= 1:8.0~),
-               clang-tools-15 (>= 1:8.0~),
-               cmake (>= 3.7~),
+               clang (>= 1:11.0~),
+               clang-tools (>= 1:11.0~),
+               cmake (>= 3.8~),
                debhelper-compat (= 13),
-               libclang-cpp15-dev (>= 1:8.0~),
-               libclang-15-dev (>= 1:8.0~),
-               llvm-15-dev (>= 1:8.0~),
+               libclang-cpp-dev (>= 1:11.0~),
+               libclang-dev (>= 1:11.0~),
+               llvm-dev (>= 1:11.0~),
                python3:any <!nocheck>,
+               libqt5networkauth5-dev <!nocheck>,
                qtbase5-dev <!nocheck>,
+               libqt5svg5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,
-Standards-Version: 4.6.1
+               qtmultimedia5-dev <!nocheck>,
+               qt6-base-dev <!nocheck>,
+               qt6-declarative-dev <!nocheck>,
+               qt6-multimedia-dev <!nocheck>,
+               qt6-networkauth-dev <!nocheck>,
+               qt6-scxml-dev <!nocheck>,
+               qt6-svg-dev <!nocheck>,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
