=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,6 @@
 
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildopts.mk
-
-export PATH := /usr/lib/llvm-15/bin:$(PATH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -29,6 +27,10 @@
 %:
 	dh $@
 
+execute_after_dh_auto_clean:
+	# cleanup the artifacts of the tests
+	find tests/ \( -name '*.o' -o -name '*.out' -o -name '*.result' -o -name '*.gch' \) -delete
+
 override_dh_auto_configure:
 	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/bin/readlink
 
@@ -38,7 +40,7 @@
 	# i.e. /usr/lib/llvm-$VERSION/lib
 	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
 	# drop extra license file
-	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/COPYING-LGPL2.txt
+	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/LGPL-2.0-or-later.txt
 	# create a local shell environment file with the various paths
 	:> $(CURDIR)/debian/debian.sh
 	echo 'export CLANG="$(CLANGPP)"' >> $(CURDIR)/debian/debian.sh
