## clazy 1.12+git20241123

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,9 +5,9 @@
 # The man page is not available on Windows.
 #
 
+cmake_minimum_required(VERSION 3.8)
+
 project(clazy)
-
-cmake_minimum_required(VERSION 3.7)
 
 if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
     cmake_policy(SET CMP0074 NEW)
@@ -19,14 +19,14 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "11")
+set(CLAZY_VERSION_MINOR "13")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 8.0 MODULE REQUIRED)
+  find_package(Clang 14.0 MODULE REQUIRED)
 
   if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
     set(default_use_clang_cpp ON)
@@ -42,8 +42,8 @@
 
 add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
 add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)
-
-option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
+add_definitions(-DCLAZY_VERSION="${CLAZY_PRINT_VERSION}")
+
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 option(CLAZY_MAN_PAGE "Builds the man page." ON)
@@ -54,11 +54,6 @@
     if (NOT MSVC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
     endif()
-endif()
-
-if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-    message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
-    add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
 endif()
 
 if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
@@ -79,27 +74,26 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 endif()
 
-# Look for std::regex support
-message("Looking for std::regex support...")
-try_run(REGEX_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
-
-if(NOT REGEX_RUN_RESULT EQUAL 0)
-  message("Using boost::regex instead of std::regex")
-  set(CLAZY_USES_BOOST_REGEX TRUE)
-  add_definitions(-DCLAZY_USES_BOOST_REGEX)
-  find_package(Boost REQUIRED COMPONENTS regex)
-  include_directories(${Boost_INCLUDE_DIRS})
-endif()
-
 set(CMAKE_CXX_STANDARD 17)
 set(CXX_STANDARD_REQUIRED ON)
 
+# Look for std::regex support
+if(NOT DEFINED REGEX_RUN_RESULT)
+  message("Looking for std::regex support...")
+  try_compile(REGEX_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
+endif()
+
+if(NOT DEFINED REGEX_RUN_RESULT)
+  message(FATAL_ERROR "std::regex support is mandatory")
+endif()
+
 # Compiler might support c++17 but not have std::filesystem in the standard library
-message("Looking for std::filesystem support...")
-try_run(FILESYSTEM_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
-
-if (FILESYSTEM_RUN_RESULT EQUAL 0 AND COMPILE_RESULT)
-    add_definitions(-DHAS_STD_FILESYSTEM)
+if (NOT FILESYSTEM_RUN_RESULT)
+  try_compile(FILESYSTEM_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
+endif()
+
+if (NOT FILESYSTEM_RUN_RESULT)
+  message(FATAL_ERROR "std::filesystem support is mandatory")
 endif()
 
 include(ClazySources.cmake)
@@ -108,10 +102,12 @@
 include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
 link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})
 
-if (${LLVM_VERSION} VERSION_GREATER_EQUAL "9.0.0")
-    set(clang_tooling_refactoring_lib clangToolingRefactoring)
-else()
-    set(clang_tooling_refactoring_lib clangToolingRefactor)
+set(clang_tooling_refactoring_lib clangToolingRefactoring)
+
+if (${LLVM_VERSION} VERSION_GREATER_EQUAL "19.0.0")
+  set(clang_support_lib clangSupport)
+elseif (${LLVM_VERSION} VERSION_GREATER_EQUAL "15.0.0")
+  set(clang_support_lib clangSupport)
 endif()
 
 macro(link_to_llvm name is_standalone)
@@ -131,6 +127,7 @@
 
       target_link_libraries(${name} ${clang_lib})
     endforeach()
+    target_link_libraries(${name} ${clang_support_lib})
     target_link_libraries(${name} clangTooling)
     target_link_libraries(${name} clangToolingCore)
     target_link_libraries(${name} ${clang_tooling_refactoring_lib})
@@ -158,9 +155,6 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
-  if (CLAZY_USES_BOOST_REGEX)
-    target_link_libraries(${name} ${Boost_LIBRARIES})
-  endif()
 endmacro()
 
 macro(add_clang_plugin name)
@@ -239,7 +233,7 @@
   install(FILES ${README_manuallevel_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/manuallevel)
 
   # Install more doc files
-  install(FILES README.md COPYING-LGPL2.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})
+  install(FILES README.md LICENSES/LGPL-2.0-or-later.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})
 
   # Build docs
   if (CLAZY_MAN_PAGE)
@@ -302,6 +296,7 @@
     clangFrontendTool
     clangRewrite
     clangSerialization
+    ${clang_support_lib}
     clangTooling
     clangStaticAnalyzerCheckers
     clangStaticAnalyzerCore
@@ -323,3 +318,11 @@
         set(str ${input_string})
         set(chunk_size 1000)
         set(result "\n")
+        string(LENGTH ${str} str_size)
+        while (${str_size} GREATER ${chunk_size})
+            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
+            string(SUBSTRING ${str} ${chunk_size} -1 str)
+            set(chunk "R\"meta(${chunk})meta\"\n")
+            string(APPEND result ${chunk})
+            string(LENGTH ${str} str_size)
+        endwhile()
