=== debian/changelog ===
clazy (1.12+git20241123-0ubuntu1) plucky; urgency=medium

  * New upstream Git snapshot.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 08 Dec 2024 21:20:15 -0600

clazy (1.12-2) unstable; urgency=medium

  * Consolidate in debian/rules the configuration of the tests to exclude,
    ensuring it can be used also in the 'run-tests' autopkgtest:
    - create a new TESTS_EXCLUDED variable, adding only the test names to it,
    - when running the tests during the build: pass --exclude to run_tests with
      a comma-separated version of $TESTS_EXCLUDED, only in case there are
      tests to exclude
    - add $TESTS_EXCLUDED to the shell configuration shipped by clazy-tests
    - switch the script of the 'run-tests' autopkgtest to use bash, so it is
      possible to use e.g. arrays
    - when running the 'run-tests' autopkgtest: pass --exclude to run_tests
      with a comma-separated version of $TESTS_EXCLUDED, only in case there are
      tests to exclude
  * Improve the way the linking with atomic is done on architectures that need
    that (i.e. currently armel):
    - generalize the addition of link flags in the tests using an environment
      variable; patch debian-tests-extra-libs.diff
    - create a new TESTS_EXTRA_LIBS variable in debian/rules, setting it to
      "-latomic" where needed
    - when running the tests during the build: export $TESTS_EXTRA_LIBS as
      $DEBIAN_EXTRA_LIBS
    - add $TESTS_EXTRA_LIBS to the shell configuration shipped by clazy-tests
    - when running the 'run-tests' autopkgtest: export $TESTS_EXTRA_LIBS as
      $DEBIAN_EXTRA_LIBS
    - drop patch debian-tests-link-atomic.diff, no more needed now

 -- Pino Toscano <pino@debian.org>  Wed, 10 Jul 2024 21:46:06 +0200
